-- vehicle parts specific helpers


function Bikinitools.VehiclePart:setContent(part, amount)
	Bikinitools:sendClientCommand("vehicle", "setContainerContentAmount", {
		vehicle = part:getVehicle():getId(),
		part = part:getId(),
		amount = amount
	});
end


function Bikinitools.VehiclePart:repair(part)
	Bikinitools:sendClientCommand("vehicle", "repairPart", {
		vehicle = part:getVehicle():getId(),
		part = part:getId()
	});
end


function Bikinitools.VehiclePart:setCondition(part, condition)
	Bikinitools:sendClientCommand("vehicle", "setPartCondition", {
		vehicle = part:getVehicle():getId(),
		part = part:getId(),
		condition = condition
	});
end


-- search functions and checks


function Bikinitools.VehiclePart:findBy(vehicle, checkFn)
    if vehicle
    then
        for i = vehicle:getPartCount() -1, 0, -1
        do
            local part = vehicle:getPartByIndex(i);

            if checkFn(part)
            then
                return part;
            end
        end
    end

    return false;
end