-- config


Bikinitools.Options:register("enableGravelBuddy", true);
Bikinitools.Automation:register("gravelBuddy");


-- methods


function Bikinitools.Automation.startGravelBuddy(player, squares, startSquare, soilType)
	if Bikinitools:isFunction(squares)
	then
		squares = squares();
	end

    Bikinitools.Automation:startSquareProcessingQueue(
        Bikinitools.Automation:getGravelBuddyTiles(squares, soilType),
        "gravelBuddyWorking",
        getText("IGUI_bikinitools_A_GravelBuddy") .. " " .. getText("IGUI_bikinitools_A_EnabledLC"),
        startSquare
    );
end


function Bikinitools.Automation:stopGravelBuddy()
    Bikinitools.Automation:stopSquareProcessingQueue(
        "gravelBuddyWorking",
        getText("IGUI_bikinitools_A_GravelBuddy") .. " " .. getText("IGUI_bikinitools_A_DisabledLC")
    );
end


function Bikinitools.Automation:checkGravelBuddyQueue(player)
	Bikinitools.Automation:checkSquareProcessingQueue({
		player = player,
		runLockVariable = "gravelBuddyWorking",
		squareFunction = {
            fn = function(square, player)
                Bikinitools.Square:extractSoil(player, square);
            end,
            param1 = player
        },
		stopFunction = function()
			Bikinitools.Automation:stopGravelBuddy()
		end,
	});
end


function Bikinitools.Automation:getGravelBuddyTiles(squares, soilType)
	if Bikinitools:isFunction(squares)
	then
		squares = squares();
	end

    return Bikinitools.Grid:filterSquaresBySoilType(squares, soilType);
end


-- context menu helper


function Bikinitools.Automation:addGravelBuddyContextMenuEntries(contextMenu, player, squaresBySize)
    local square = Bikinitools.Square:getCurrent(player);
    local soilType, soilTile = Bikinitools.Square:getSoilType(square);
    local shovel = Bikinitools.Item:findNonBrokenInInventoryByTag(player, "TakeDirt");
    local gravelBuddyMenu = Bikinitools:addContextMenuSubMenu(contextMenu,
        getText("IGUI_bikinitools_A_GravelBuddy")
    );

    if shovel
    then
        if square and soilType --and square:getZ() == 0
        then
            local bagType, emptyBag = Bikinitools.Item:getFillableBagForSoil(player, soilType);

            if emptyBag
            then
                for radius = Bikinitools.Automation.min3x3radius, Bikinitools.Automation.max3x3radius
                do
                    Bikinitools:addContextMenuItem(gravelBuddyMenu,
                        getText("IGUI_bikinitools_A_PickUpSoilInArea",
                            getText("IGUI_bikinitools_A_Soil" .. Bikinitools:ucFirst(soilType)),
                            getText("IGUI_bikinitools_A_Radius" .. radius)
                        ),
                        Bikinitools.Automation.startGravelBuddy, {player, squaresBySize[radius], square, soilType}
                    );
                end
            else
                Bikinitools:addDisabledContextMenuItem(gravelBuddyMenu, Bikinitools:ucFirst(getText("IGUI_bikinitools_A_DisabledLC")) .. ": " .. getText("IGUI_bikinitools_A_NoEmptyBag"));
            end
        else
            Bikinitools:addDisabledContextMenuItem(gravelBuddyMenu, Bikinitools:ucFirst(getText("IGUI_bikinitools_A_DisabledLC")) .. ": " .. getText("IGUI_bikinitools_A_WrongSoil"));
        end
    else
        Bikinitools:addDisabledContextMenuItem(gravelBuddyMenu, Bikinitools:ucFirst(getText("IGUI_bikinitools_A_DisabledLC")) .. ": " .. getText("IGUI_bikinitools_A_NoShovel"));
    end
end