-- config


Bikinitools.Options:register("enableOpenSesame", false);
Bikinitools.Options:register("useOpenSesameAltText", false);


-- methods


function Bikinitools.Vehicle.unlockRandomDoor(vehicle)
    if vehicle
    then
        local doorPart = Bikinitools.Vehicle:getFirstDoor(vehicle);

        if doorPart
        then
            Bikinitools:message(getText("IGUI_bikinitools_V_OpenDoorFound"));

            --doorPart:getDoor():setLocked(false);

			--Commands.setDoorLocked(Bikinitools:getPlayer(), {
				--vehicle = vehicle:getId(),
				--part = doorPart:getId(),
				--locked = false
			--});

			Bikinitools:sendClientCommand("vehicle", "setDoorLocked", {
				vehicle = vehicle:getId(),
				part = doorPart:getId(),
				locked = false
			});
        else
            Bikinitools:message(getText("IGUI_bikinitools_V_OpenDoorFail"));
        end
    end
end


-- context menu helper


function Bikinitools.Vehicle:addOpenSesameContextMenuEntry(contextMenu, attachedObject, vehicle)
    if vehicle:getPartCount() > 0 and vehicle:areAllDoorsLocked()
    then
		Bikinitools:addContextMenuItem(contextMenu,
			getText(Bikinitools.ternary(
				Bikinitools.Options.useOpenSesameAltText,
				"IGUI_bikinitools_V_OpenSesameAlt",
				"IGUI_bikinitools_V_OpenSesame"
			)),
			Bikinitools.Vehicle.unlockRandomDoor, {
				vehicle
			}
		);
    end
end
