-- config


Bikinitools.Options:register("enableVehiclePositionSaver", false);
Bikinitools.Vehicle.positionSaverQueryFile = "bikinitools_vpos.sql";
Bikinitools.Vehicle.positionList = {};

-- methods

function Bikinitools.Vehicle.clearPositionsList()
	Bikinitools.Vehicle.positionList = {};
end


function Bikinitools.Vehicle.addPositionsInCell()
	local player = Bikinitools:getPlayer();
    local vehicles, vehicleCount = Bikinitools.Vehicle:getVehiclesInCell(player:getCell(), player);

    for i, vehicle in ipairs(vehicles)
    do
        Bikinitools.Vehicle.positionList[vehicle:getX()] = vehicle:getY();
    end
end


function Bikinitools.Vehicle.dumpPositionsSQLQuery()
	local file = getFileWriter(Bikinitools.Vehicle.positionSaverQueryFile, true, false);
	local query = "DELETE FROM vehicles\nWHERE(\n";
	local index = 0;
	local length = Bikinitools:countArrayElements(Bikinitools.Vehicle.positionList);

	for x, y in pairs(Bikinitools.Vehicle.positionList)
    do
		index = index + 1;
		query = query .. " NOT (x = " .. tostring(x) .. " AND y = " .. tostring(y) .. ")\n";

		if index < length
		then
			query = query .. " AND";
		end
    end

	query = query .. ")";

	file:write(query);
	file:close();

	Bikinitools:message("wrote query to %userdata%\\Zomboid\\Lua\\" .. Bikinitools.Vehicle.positionSaverQueryFile);
end


-- context menu helper


function Bikinitools.Vehicle:addPositionSaverContextMenuEntry(contextMenu, attachedObject, vehicle)
	local saverMenu = Bikinitools:addContextMenuSubMenu(contextMenu,
        "Position saver"
    );

	Bikinitools:addContextMenuItem(saverMenu,
		"Clear positions list",
		Bikinitools.Vehicle.clearPositionsList
	);

	Bikinitools:addContextMenuItem(saverMenu,
		"Add positions of vehicles in current cell",
		Bikinitools.Vehicle.addPositionsInCell
	);

	Bikinitools:addContextMenuItem(saverMenu,
		"Dump current list as SQL query",
		Bikinitools.Vehicle.dumpPositionsSQLQuery
	);

	Bikinitools:addContextMenuItem(saverMenu,
		"Take cell inventory and dump query",
		function()
			Bikinitools.Vehicle.clearPositionsList();
			Bikinitools.Vehicle.addPositionsInCell();
			Bikinitools.Vehicle.dumpPositionsSQLQuery();
		end
	);
end