-- config


Bikinitools.Options:register("enableVehicleRemover", false);
Bikinitools.Options:register("enableCellVehicleRemover", false);


-- methods


function Bikinitools.Vehicle:getVehiclesInCell(cell, player)
    local objects = cell:getVehicles();
    local objCount = objects:size();
    local vehicles = {};
    local vehicleCount = 0;

    if not player
    then
        player = Bikinitools:getPlayer();
    end

    for i = 1, objCount
    do
        local object = objects:get(i - 1);

        if string.match(tostring(object), "BaseVehicle") and object ~= player:getVehicle()
        then
            table.insert(vehicles, object);
            vehicleCount = vehicleCount + 1;
        end
    end

    return vehicles, vehicleCount;
end


function Bikinitools.Vehicle:removeInRealityBubble()
    local player = Bikinitools:getPlayer();
    local vehicles, vehicleCount = Bikinitools.Vehicle:getVehiclesInCell(player:getCell(), player);

    for i, vehicle in ipairs(vehicles)
    do
        Bikinitools.Vehicle:remove(vehicle);
    end

    Bikinitools:message(getText("IGUI_bikinitools_V_XVehiclesRemoved", vehicleCount));
end


-- context menu helper


function Bikinitools.Vehicle:addRemoveContextMenuEntry(contextMenu, player, vehicle)
    Bikinitools:addContextMenuItem(contextMenu,
        getText("IGUI_bikinitools_V_RemoveVehicle"),
        function(vehicle)
            Bikinitools:showModalDialog(
                getText("IGUI_bikinitools_V_ConfirmRemoveVehicle"),
                function()
                    Bikinitools.Vehicle:remove(vehicle);
                end
            )
        end, {
            vehicle
        }
    );
end


function Bikinitools.Vehicle:addRemoveInCellContextMenuEntry(contextMenu, player, vehicle)
    Bikinitools:addContextMenuItem(contextMenu,
        getText("IGUI_bikinitools_V_RemoveVehicleCell"),
        function(vehicle)
            Bikinitools:showModalDialog(
                getText("IGUI_bikinitools_V_ConfirmRemoveVehicleCell"),
                function()
                    Bikinitools.Vehicle:removeInRealityBubble();
                end
            )
        end, {
            vehicle
        }
    );
end