--if isClient()
--then
	--return;
--end


-- commands


function Bikinitools.Commands.setVehicleData(playerObj, args)
	--print("Bikinitools.Commands.setVehicleData(" .. playerObj:getUsername() .. ", " .. args["_vehicleId"] .. ")");

	local vehicle = getVehicleById(args["_vehicleId"]);

	if vehicle
	then
		local part = Bikinitools.Vehicle:getMulePart(vehicle);

		if part
		then
			--print("setting mod data");

			local modData = part:getModData();

			for k, v in pairs(args)
			do
				if k ~= "_vehicleId"
				then
					--print("- setting " .. tostring(k) .. " = " .. tostring(v));
					modData[k] = v;
				end
			end

			vehicle:transmitPartModData(part);
		--else
			--print("unable to find mule part");
		end
	--else
		--print("unable to find vehicle");
	end
end


function Bikinitools.Commands.setVehicleSkinIndex(playerObj, args)
	--print("Bikinitools.Commands.setVehicleSkinIndex(" .. playerObj:getUsername() .. ", " .. args["_vehicleId"] .. ")");

	local vehicle = getVehicleById(args["_vehicleId"]);

	if vehicle
	then
		vehicle:setSkinIndex(args["skinIndex"]);

		Bikinitools.Vehicle:reloadSkin(vehicle);

		for i, player in ipairs(Bikinitools:getOnlinePlayers())
		do
			sendServerCommand(player, "bikinitools_client", "reloadVehicleSkin", args);
		end
	--else
		--print("unable to find vehicle");
	end
end


function Bikinitools.Commands.reloadVehicle(playerObj, args)
	--print("Bikinitools.Commands.reloadVehicle(" .. playerObj:getUsername() .. ", " .. args["_vehicleId"] .. ")");

	local vehicle = getVehicleById(args["_vehicleId"]);

	if vehicle
	then
		Bikinitools.Vehicle:reloadSkin(vehicle);
	--else
		--print("unable to find vehicle");
	end
end