Bikinitools.Config = {
    settingsFile = "bikinitools.ini",
    restrictedSettingsFile = "bikinitools_restricted.ini",
    lastLoadedSettingsFile = nil,

    icons = {
        zoidbergS = "media/ui/bikinitools_16.png",
        zoidbergM = "media/ui/bikinitools_17.png",
        zoidbergL = "media/ui/bikinitools_24.png",
        zoidbergXL = "media/ui/bikinitools_32.png",

        arrow1 = "media/ui/zoidarrow.png",
        arrow2 = "media/ui/zoidarrow2.png",

        checkmark = "media/ui/zoidcheck.png",
        checkmark2 = "media/ui/zoidcheck2.png",
    },

    colors = {
        contextR = 0,
        contextG = 0,
        contextB = 0,

        highlightR = 255,
        highlightG = 87,
        highlightB = 87,

        mouseOverR = 0,
        mouseOverG = 0,
        mouseOverB = 0,
    },

    -- vehicle data mule crutch

    muleParts = {
        "GloveBox",
        "TruckBed",
        "TrailerTrunk",
        "TruckBedOpen",
		"M101A3Trunk",
        "Engine",
    },

    -- corpse stacker max weight

    maxCorpseWeight = 20,

    -- vehicle id list of vehicles breaking on skin change in mp

    disableSkinChange = {
        "Base.ATAMustangClassic"
    },
};


Bikinitools.Options = Bikinitools:mergeArrays({
    beReadyForFeatureToggles = false,
    needRestart = {},

    silentMode = false,
    recolorContextMenu = false,
    enableIconOverride = true,

    configMenuItems = {
        ["bikinitools"] = {
            "silentMode",
            "recolorContextMenu",
            "enableIconOverride",
            "beReadyForFeatureToggles",
			--"fullyDisableBT",
        },
        ["IGUI_bikinitools_O_Context_VehicleSpawner"] = {
            "enableVehicleSpawner",
            "spawnVehiclesFullyRepaired",
            "spawnVehiclesWithKey",
        },
        ["IGUI_bikinitools_O_Context_VehicleSkinSwitcher"] = {
            "enableSkinSwitcher",
            "useSkinNamesNotIndices",
        },
        ["IGUI_bikinitools_O_Context_VehicleUnlocker"] = {
            "enableOpenSesame",
            "useOpenSesameAltText",
            "enableTrunkUnlocker",
            "enableGetKeyContext",
        },
        ["IGUI_bikinitools_O_Context_VehicleRepair"] = {
            "enableRepairContext",
        },
        ["IGUI_bikinitools_O_Context_VehicleRemover"] = {
            "enableVehicleRemover",
            "enableCellVehicleRemover",
        },
        ["IGUI_bikinitools_O_Context_HideShowItems"] = {
            "enableVehicleItemHide",
            "putHiddenItemsInBackpack",
        },
        ["IGUI_bikinitools_O_Context_GravelBuddy"] = {
            "enableGravelBuddy",
            --"predetermineAreaViability",
            "lowPerformanceQueueMode",
            "enableFunSizeRadii",
        },
        ["IGUI_bikinitools_O_Context_Gardener"] = {
            "enableGardener",
            --"predetermineAreaViability",
            "lowPerformanceQueueMode",
            "enableFunSizeRadii",
        },
        ["IGUI_bikinitools_O_Context_Lumberjack"] = {
            "enableLumberjack",
            --"predetermineAreaViability",
            "lowPerformanceQueueMode",
            "enableFunSizeRadii",
        },
        ["IGUI_bikinitools_O_Context_ContainerUnloader"] = {
            "enableContainerUnloader",
            --"predetermineAreaViability",
            "lowPerformanceQueueMode",
            "enableFunSizeRadii",
        },
        ["IGUI_bikinitools_O_Context_HomeWrecker"] = {
            "enableHomeWrecker",
            "unloadContainersBeforeScrapping",
            "pickUpNailsAfterScrapping",
            "dropElectronicsAfterScrapping",
            --"predetermineAreaViability",
            "lowPerformanceQueueMode",
            "enableFunSizeRadii",
        },
        ["IGUI_bikinitools_O_Context_CorpseStacker"] = {
            "enableCorpseStacker",
            --"predetermineAreaViability",
            "lowPerformanceQueueMode",
            "enableFunSizeRadii",
        }
    },

    brokenInMP = {
        --"enableSkinSwitcher",
    },

	obsolete = {
		"predetermineAreaViability"
	}
}, Bikinitools.Options or {});


-- leaves possibility to account for change from outside. to change what is restricted and what not, create a mod setting this before bt is initialized. DON'T OVERRIDE ANY LUA FILES FOR THAT!
-- explanation: https://steamcommunity.com/workshop/filedetails/discussion/2634426926/3198119216803686504/
-- example file in bt media folder: BT_MP_CheatConfigExample.lua

Bikinitools.Options.restrictedInMP = Bikinitools.Options.restrictedInMP or {
    "enableGetKeyContext",          -- get vehicle keys
    "enableOpenSesame",             -- open random door on locked vehicle
    "enableVehicleRemover",         -- remove a single vehicle
    "enableCellVehicleRemover",     -- remove all vehicles in a cell
    "enableRepairContext",          -- repair vehicle
    "enableSkinSwitcher",           -- vehicle skin switcher
    "enableVehicleSpawner",         -- vehicle spawner
    "enableTrunkUnlocker",          -- unlock locked trunks
    --"enableGravelBuddy",            -- gravel buddy automation
    --"enableGardener",               -- gardener automation
    --"enableLumberjack",             -- lumberjack automation
    --"enableContainerUnloader",      -- container unloader automation
    "enableHomeWrecker",            -- home wrecker automation
    --"enableCorpseStacker",          -- corpse stacker automation
    --"enableVehicleItemHide",        -- hide/show items on vehicle enter/leave
};


-- color calculations rbg -> factor
for name, color in pairs(Bikinitools.Config.colors)
do
    Bikinitools.Config.colors[name] = color / 255;
end


-- (re-)apply what is considered cheating
function Bikinitools.Options:applyCheatRestrictions()
	if not Bikinitools:playerCanCheat()
	then
		Bikinitools.Options:restrictCheats();
		Bikinitools.Options:save();
	end
end