function Bikinitools.Vehicle:getMulePart(vehicle)
	if vehicle
	then
		for i, partId in ipairs(Bikinitools.Config.muleParts)
		do
			local part = vehicle:getPartById(partId);

			if part
			then
				return part;
			end
		end

		print("mule part not found");
	else
		print("vehicle not found");
	end

	return nil;
end


function Bikinitools.Vehicle:reloadSkin(vehicle)
    if vehicle
    then
		local conditions = {};
		local items = {};

		-- remember conditions and items

		for i = 0, vehicle:getPartCount() -1
		do
			local part = vehicle:getPartByIndex(i);

			if not Bikinitools.VehiclePart:isMissing(part)
			then
				local partId = part:getId();
				local inventoryItem = part:getInventoryItem();

				conditions[partId] = part:getCondition();

				if inventoryItem
				then
					items[partId] = inventoryItem;
				end
			end
		end

		-- creates new and removes installed parts, for whatever fucked up reason

		vehicle:scriptReloaded();

		-- go through all parts installed, then check if in conditions-array and uninstall as needed

		for i = 0, vehicle:getPartCount() -1
		do
			local part = vehicle:getPartByIndex(i);
			local partId = part:getId();

			if part
			then
				if conditions[partId]
				then
					local item = items[partId];

					if items[partId]
					then
						part:setInventoryItem(item);
					end

					part:setCondition(conditions[partId]);
				else
					part:setInventoryItem(nil);
				end

				vehicle:transmitPartItem(part);
			end
		end

		-- exception for variants

		if KI5 and KI5.loadedParts
		then
			local name = vehicle:getScript():getName();

			for vName, config in pairs(KI5.loadedParts)
			do
				if name == vName and config.rootNS and config.parts
				then
					for partNS, isInitialized in pairs(config.parts)
					do
						config.rootNS[partNS](vehicle);
					end

					local tank = vehicle:getPartById("GasTank");

                    if tank
                    then
                        tank:setContainerContentAmount(tank:getContainerCapacity() * 0.5);
                    end
				end
			end
		end
    end
end